import javax.bluetooth.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.*;

public class EndPoint
{
    
    RemoteDevice remoteDev;
    DeviceClass remoteClass;
    String remoteUrl;
    StreamConnection con;
    int transID=-1;
    Sender sender;
    Reader reader;
    String localName;
    String remoteName;
    String remotebtaddr;
    String localmaster=null;
    SubsystemInvoker callback;
    
    NetLayer btnet;
    Vector reachableslaves =new Vector();
    Vector msgs = new Vector(); //this is the message queue
    
    
    
    public EndPoint( NetLayer btnet, RemoteDevice rdev, StreamConnection c )
    {
        this.btnet = btnet;
        remoteDev = rdev;
        try {
             remoteName = rdev.getFriendlyName(false); 
        }catch (IOException ex) {
            remoteName = "Unknown";
        }
        
        localName=btnet.localName;
        remotebtaddr=rdev.getBluetoothAddress();
        callback = btnet.callback;
        con = c;
        
        sender = new Sender();
        sender.endpt = this;

        reader = new Reader();
        reader.endpt = this;
    }
 public  synchronized void slavesExtractor(String s)
 {
    
      while(true)
      {
            int i=s.indexOf(";");
            String temp=s.substring(0,i);
            reachableslaves.addElement(temp);
            if(s.length()-1==s.indexOf(";")) break;
            s= s.substring(i+1);
      }
      
			
  }
    public synchronized void putString(int signal,String s){
        log("invoke putString "+signal+" "+s);
        msgs.addElement( new Packet( signal,localName, s ) );
        synchronized( sender )
        {
            // tell sender that there is a message pending to be sent
            sender.notify();
        }
    }
    public synchronized void putString(int signal,String source,String msg,String des){
        log("invoke putString "+signal+" "+msg);
        msgs.addElement( new Packet(source,des ,signal, msg ) );
        synchronized( sender )
        {
            // tell sender that there is a message pending to be sent
            sender.notify();
        }
    }
    public synchronized Packet getString()
    {
        if ( msgs.size() > 0 )
        {
            // if there are message pending, return it and remove it from the vector
             Packet s = (Packet) msgs.firstElement();
             msgs.removeElementAt(0);
            return s;
        } else
              return null;
    
  }
        
    public synchronized boolean peekString()
    {
        return ( msgs.size() > 0 );
    } 
    private static void log( String s )
    {
        Scattercom.log(s);
    }
}
    
        
    
