/**
 *
 * @author  Sreejith
 * @version
 */
import javax.microedition.midlet.*; 
import javax.microedition.lcdui.*; 
import java.util.*; 

import javax.microedition.io.file.*;
import javax.microedition.io.*;


public class FileSearchDisplayCanvas extends CustomItem  
                                  implements ItemCommandListener {
    
    private static int stringIndex = 0; 
                                                                            
    private final int WIDTH, HEIGHT; 
    private int Index =0;
    private Vector elements = new Vector();
    private int size=0;
    
    private int lastIndex=0;

    private Image folderImage;
    private Image fileImage;
    private Image downArrowImage;
    private Image upArrowImage;
    
  
    private boolean stopped=false;
    private Font small_Font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
    private Font medium_Font = Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_MEDIUM);
    private int font_medium_Height;
    private int font_small_Height;
    private int font_medium_Width;
    private int font_small_Width;
    private int text_button_Width;    
    
    
   
    private int visibleTopIndex;
    private int visibleBottomIndex;
    private int visibleBottomIndex_START;
   
     private Displayable next; 
    
    public FileSearchDisplayCanvas(String title, int w, int h)
    {
        
        super("File Search Results: ");
        this.next=next; 
        WIDTH = w; 
        HEIGHT = h;         
        setProperties();
        loadProgramImages();
        
        
    }

    public void keyPressed(int key){ 
        
        System.out.println("keypressed"+String.valueOf(key));
        switch(key){ 
            case 50: // UP
                if(Index==0)
                        return;
                if(visibleTopIndex==0){
                        Index--;
                        
                }
                else {
                    Index--;
                    visibleTopIndex--;
                    visibleBottomIndex--;
                    
                }
                repaint();
                break; 
            case 56: // DOWN
                if(Index>=elements.size()-1)
                        return;
                else if(visibleBottomIndex>Index+1){
                        Index++;
                        
                }
                else {
                    Index++;
                    visibleBottomIndex++;
                    visibleTopIndex++;
                    
                }
                repaint();
                break; 

            case -5: // FIRE
                    clickEvent();
                break;
            case -11: // BACK
                this.stopped=true;
               //stopping step
                
                break; 
        } 
        
    
    } 
    
    public void clearResults()
    {
        elements.removeAllElements();
        repaint();
    }
    public void addResult(String s)
    {

        lastIndex=0;
        visibleTopIndex=0;
        visibleBottomIndex=visibleBottomIndex_START;
        Index=0;
        elements.addElement(s);
        lastIndex++;
        size=elements.size();

        repaint();
        
    } 


    private void clickEvent()
    {
        String choosenDir = (String)elements.elementAt(Index);
        System.out.println(choosenDir);
        // do what ever u want using canvas selected item
    
    }

private void setProperties()
{
        font_medium_Height= medium_Font.getHeight();
        font_small_Height= small_Font.getHeight();
        font_medium_Width= medium_Font.charWidth('w');
        font_small_Width= small_Font.charWidth('w');
        text_button_Width=font_medium_Width*4;
        visibleTopIndex=0;
        visibleBottomIndex_START=(HEIGHT - 4* font_medium_Height)/font_small_Height;
        visibleBottomIndex=visibleBottomIndex_START;
}
// Loading the program images 
private void loadProgramImages()
{
    try{
        folderImage = Image.createImage("/res/folder.PNG");
        fileImage = Image.createImage("/res/folder.PNG");
        downArrowImage = Image.createImage("/res/downArrow.PNG");
        upArrowImage = Image.createImage("/res/upArrow.PNG");
    }
    catch(Exception e){System.out.println("LoadProgramImages:"+e.toString());}
    
}

    protected int getMinContentWidth() {
        return WIDTH;
    }

    protected int getMinContentHeight() {
        return HEIGHT;
    }

    protected int getPrefContentWidth(int i) {
        return HEIGHT;
    }

    protected int getPrefContentHeight(int i) {
        return WIDTH;
    }


    protected void paint(Graphics g, int w, int h) {
        
        g.setColor(0xFFFFFF); 
        g.fillRect(0, 0, WIDTH, HEIGHT); 
        g.setColor(0x00); 
        g.setFont(small_Font); 
        int lastIndex = visibleBottomIndex < size? visibleBottomIndex:size;
        int j = 0;
        for(int i = visibleTopIndex; i<lastIndex;++i)
         {
                //draw the current item in the directory list as marked
                if(Index==i){ 
                    g.setColor(83,148,166); 
                    g.drawRoundRect(0, font_medium_Height+(j)*font_small_Height,WIDTH, font_small_Height, 4, 2);
                }
                    if(i<lastIndex)
                    {
                        //if the item is a directory draw the directory image before the name
                        g.drawImage(folderImage,0,font_medium_Height+(j)*font_small_Height, 0);
                    }
                    else    // if the item is a file draw the file image before the name
                        g.drawImage(folderImage,0,font_medium_Height+(j)*font_small_Height, 0);
                // Draw the file or the Directory name
                g.drawString((String)elements.elementAt(i), 16,font_medium_Height+(j)*font_small_Height, 0); 
                g.setColor(0x00); 
                j++;
            }

            
            g.setColor(83,148,166); 
            if(this.visibleBottomIndex<size) // If There are more items below, draw an arrow downward to indicate this
                g.drawImage(downArrowImage,WIDTH-30,HEIGHT-font_medium_Height*2-10, 0);    
            if(this.visibleTopIndex>0) // If There are more items above, draw an arrow above to indicate this
                g.drawImage(upArrowImage,WIDTH-30,0+font_medium_Height, 0);
            
    
            g.drawLine(0, HEIGHT-font_medium_Height*2, WIDTH, HEIGHT-font_medium_Height*2);

       
        g.setColor(0,0,0); 
    }

    public void commandAction(Command command, Item item) {
    }

}


