

import javax.microedition.io.*;
import javax.bluetooth.*;
import java.io.*;
import java.util.*;
import javax.microedition.lcdui.*;

public class NetLayer implements Runnable,CommandListener{

  public final static int SIGNAL_MASTER_REQUEST = 0;
  public final static int SIGNAL_I_AM_UR_SLAVE=1;
  public final static int SIGNAL_CANT_BE_SLAVE=2;
  public final static int SIGNAL_BE_MASTER_AND_DO_DISCOVERY=3;
  public final static int SIGNAL_ACTED_AS_MASTER=4;
  public final static int SIGNAL_SCATTERNET_BROADCAST_ADD=5;
  public final static int SIGNAL_SCATTERNET_BROADCAST_REMOVE=6;
  public final static int SIGNAL_ADD_UPDATE=7;
  public final static int SIGNAL_REMOVE_UPDATE=8;
  public final static int SIGNAL_MESSAGE = 9;
  public final static int SIGNAL_BROADCAST=10;
  public final static int SIGNAL_TERMINATE = 11;
  public final static int SIGNAL_TERMINATE_ACK = 12;
  public final static int SIGNAL_VIEW_PROFILE=13;
  public final static int SIGNAL_PROFILE=14;
  public final static int SIGNAL_SCRAP_RESPONSE=15;
  public final static int SIGNAL_SUBMIT_SCRAP=16;
  public final static int SIGNAL_CONTACTS_NUM_REQUEST=17;
  public final static int SIGNAL_CONTACTS_NAME_REQUEST=18;
  public final static int SIGNAL_CONTACTS_RESPONSE=19;
  public final static int SIGNAL_FILE_SEARCH_REQUEST=20;
  public final static int SIGNAL_FILE_SEARCH_RESPONSE=21;
  
   public List deslist;
 
  private final static UUID uuid = new UUID("1A2B3C4D5E6F7A8B9C1D2E3F4A5B6C7D", false);
  private final static int SERVICE_TELEPHONY = 0x400000;
  LocalDevice localDevice = null;
  DiscoveryAgent agent = null;
  StreamConnectionNotifier server;
  SubsystemInvoker callback=null;
  Display display;
  int senduitype=1;
  
   boolean done = false;
   String localName = "";
   String bluetoothaddress = "";
   String exclusionstring;
   
   Vector master_request_endpoints = new Vector();
   Vector slave_request_endpoints = new Vector();
   Vector slave_endpoints = new Vector();
   Vector pendingEndPoints = new Vector();
   Vector endpoints=new Vector();
   Vector exclusionendpt=new Vector();
   Nodes nodes=new Nodes();
   boolean pseudorootmaster=false;
   
   
   
   Hashtable serviceRecordToEndPoint = new Hashtable();
   Object lock = new Object();
   MasterID master=new MasterID();
   MasterRequest masterreq=new MasterRequest();
   MasterSlaveOrder masterorder= new MasterSlaveOrder();
   Vector serviceRecord = new Vector();
   Vector endpointserRcd= new Vector();
   
   public NetLayer(Display display){
        this.display=display;
   }
   public void init(SubsystemInvoker callback){
    
      log( "invoke init()" );
      try{
          this.callback = callback;
          localDevice = LocalDevice.getLocalDevice();
          this.localName=localDevice.getFriendlyName();
          localDevice.setDiscoverable(DiscoveryAgent.GIAC);
          agent=localDevice.getDiscoveryAgent();
          bluetoothaddress=localDevice.getBluetoothAddress();
          log( "Local Device Bluetooth Address"+localDevice.getBluetoothAddress());
          log("Local Device Name"+localDevice.getFriendlyName());
          Thread thread = new Thread( this );
          thread.start();
          
      }
      catch (BluetoothStateException e) {
            e.printStackTrace();
            log(e.getClass().getName()+" "+e.getMessage());
      }
       catch (IOException e) {
      e.printStackTrace();
      log(e.getClass().getName()+" "+e.getMessage());

    }
  }
  public void sendUI(int type) {
      
        this.senduitype=type;
        
        if(type==SIGNAL_FILE_SEARCH_REQUEST||type==SIGNAL_CONTACTS_NUM_REQUEST)
            deslist =new List("Destinations",Choice.IMPLICIT,nodes.allNodesplusall(),null);
        else
            deslist =new List("Destinations",Choice.IMPLICIT,nodes.allNodes(),null);
       deslist.addCommand(new Command("OK", Command.SCREEN, 1));
       deslist.addCommand(new Command("Back", Command.EXIT ,2));
       deslist.setCommandListener(this);
       display.setCurrent(deslist);
       
    }
  public void commandAction(Command command, Displayable displayable) {
        if ( command.getLabel().equals("OK") )
        {
            if(senduitype==SIGNAL_VIEW_PROFILE)
            {
                log("sending view profile command");
                log("msg " +localName+" source : "+ bluetoothaddress+"dest "+deslist.getString(deslist.getSelectedIndex()));
                sendString(SIGNAL_VIEW_PROFILE,localName,bluetoothaddress,deslist.getString(deslist.getSelectedIndex()));
                display.setCurrent(Scattercom.instance.profile);
                
                
            }
            else if(senduitype==SIGNAL_MESSAGE)
            {
                log("sending message");
                display.setCurrent(Scattercom.messageui);
                Scattercom.instance.messageui.sendMessage(deslist.getString(deslist.getSelectedIndex()));
            }
            else if (senduitype == SIGNAL_FILE_SEARCH_REQUEST)
            {
                String s=deslist.getString(deslist.getSelectedIndex());
                if(s.compareTo("All")==0)
                {    log("Sending file search Request");
                    String dest[]=nodes.allNodes();
                    for (int i = 0; i < nodes.getCount(); i++)
                    {
                        log("Sending File Search Request to " +dest[i]);
                        Scattercom.instance.fsi.sentNetworkRequest(bluetoothaddress,dest[i]);
                    }
                }
                else
                {   
                    log("Sending File Search Request to " +s);
                    Scattercom.instance.fsi.sentNetworkRequest(bluetoothaddress,s);
                    
                }
                Scattercom.instance.fsi.startFileSearch();   
            }
            else if (senduitype == SIGNAL_CONTACTS_NUM_REQUEST)
            {
                String s=deslist.getString(deslist.getSelectedIndex());
                if(s.compareTo("All")==0)
                {    log("Sending Contact Request");
                    String dest[]=nodes.allNodes();
                    for (int i = 0; i < nodes.getCount(); i++)
                    {   log("Sending Contact Search Request to " +dest[i]);
                        Scattercom.instance.csi.sentNetworkRequest(bluetoothaddress,dest[i]);
                    }
                }
                else
                {   
                    log("Sending Contacts Search Request to " +s);
                    Scattercom.instance.csi.sentNetworkRequest(bluetoothaddress,s);
                    
                }
                Scattercom.instance.csi.startContactSearch() ;  
            }
      
       }
       if ( command.getLabel().equals("Back") )
       {
            display.setCurrent(Scattercom.instance.profile); 
       }
       
    }
public void sendString( int signal,String msg,String source,String dest)
  {
      boolean flag=true;
      EndPoint ept=slave(dest);
      if(ept!=null)
      {
            ept.putString(signal,source,msg,dest);
      }
      else if(master.isRoot())
      {
          sendString(SIGNAL_MESSAGE,"Destination Not reachable",localName,source);
      }
      else
      {
          master.masterendpt.putString(signal,source,msg,dest);
      }
  }
  public void cleanupRemoteEndPoint( EndPoint endpt )
  {
        log("invoke cleanupRemoteEndPoint() :" +endpt.remotebtaddr);
        endpt.reader.stop();
        endpt.sender.stop();
  }   
   
   public void run() {
       
      StreamConnection c = null;
      try{
          // Actually registering Service Record in Service Discovery Database
          server =  (StreamConnectionNotifier)Connector.open(
          "btspp://localhost:" + uuid.toString() +";name=Bluecom");
          ServiceRecord rec = localDevice.getRecord( server );
          rec.setAttributeValue( 0x0008, new DataElement( DataElement.U_INT_1, 0xFF ) );
          rec.setDeviceServiceClasses(
          SERVICE_TELEPHONY  );
          log("Service Record Created");
      }
      catch (Exception e){
              e.printStackTrace();
              log(e.getClass().getName()+" "+e.getMessage());
      }
      
      while( !done)
      {
            try {
                log("local service waiting for client connection");
                Scattercom.instance.gui_log( "", "Ready to accept connection. Wait..." );
                c = server.acceptAndOpen();
                RemoteDevice rdev = RemoteDevice.getRemoteDevice( c );
                EndPoint endpt = findEndPointByRemoteDevice( rdev );
                if ( endpt != null )
                {
                      log("client connection end point already exist.. ignore this connection");
                } 
                else
                {
                      // - create a new EndPoint object
                      // - initialize the member variables
                      // - start the data reader and sender threads.
                    endpt = new EndPoint( this, rdev, c);

                    Thread t1 = new Thread( endpt.sender );
                    t1.start();
       
                    Thread t2 = new Thread( endpt.reader );
                    t2.start();

          
                    master_request_endpoints.addElement( endpt );
                    log("a new active EndPoint is established. name=" + endpt.remoteName);

             }                   
             
               
         } catch (Exception e)
         {
              e.printStackTrace();
              log(e.getClass().getName()+" "+e.getMessage());
              if (c != null)
                try {
                 c.close();
                }
                catch (IOException e2) {
                }
         }
              
     }
       
}
public EndPoint findEndPointByRemoteDevice( RemoteDevice rdev )
  {
        for ( int i=0; i < master_request_endpoints.size(); i++ )
        {
            EndPoint endpt = (EndPoint) master_request_endpoints.elementAt( i );
            if ( endpt.remoteDev.equals( rdev ) )
            {
                 return endpt;
            }
        }
        return null; // not found, return null
  }   
   
   // Device discovery to form scatternet or join scatternet
 public void query()
  {
    try {
        log("invoke query()");
        master_request_endpoints.removeAllElements();
        agent.startInquiry(DiscoveryAgent.GIAC, new Listener());
    }
    catch (BluetoothStateException e)
    {
      e.printStackTrace();
      log(e.getClass().getName()+" "+e.getMessage());

    }
  }
   public void disconnect()
  {
        log("invoke disconnect()");
        // stop server socket, not longer accept client connection
        done = true;

        /*for ( int i=0; i < slave_endpoints.size(); i++ )
        {
            EndPoint endpt = (EndPoint) slave_endpoints.elementAt( i );
            endpt.putString( NetLayer.SIGNAL_TERMINATE, "end" );
            endpt.sender.stop();
            endpt.reader.stop();
       }
       master.masterendpt.putString( NetLayer.SIGNAL_TERMINATE, "end" );
       master.masterendpt.sender.stop();
       master.masterendpt.reader.stop();*/
  }
public void canIBeMaster()
{
    
    
    
    masterreq.MasterRequest(master_request_endpoints.size(),this);
    log("invoke can i be master"+ String.valueOf(master_request_endpoints.size()));
    int i,j=0;
    for ( i=0; i < master_request_endpoints.size(); i++ )
    {
        EndPoint endpt = (EndPoint) master_request_endpoints.elementAt( i );
        log("Sending Master Request to " +endpt.remotebtaddr);
        endpt.putString( NetLayer.SIGNAL_MASTER_REQUEST,  bluetoothaddress);
        j=1;
    }
    if(j==0)
    {
        log("master request null");
         if(!master.isRoot())
         {
              if(master.masterendpt==null)log("master not set");
              if(pseudorootmaster)
              { 
                log("Converting ACTED_AS_MASTER to ADD_UPDATE signal");
                master.masterendpt.putString(NetLayer.SIGNAL_ADD_UPDATE,reachableSlaves());
              }
              else
              {
                log("1 Sending ACTED_AS_MASTER to " +master.btadder+"with name"+master.masterendpt.remoteName);
                master.masterendpt.putString(NetLayer.SIGNAL_ACTED_AS_MASTER,bluetoothaddress+":"+master.masterendpt.localName+";");
              }
             
         }
        
    }
    
}

 public void responseComplete(){
     log("Involve Response Complete");
     masterreq.done();
     if(!master.isMasterIDSet())
     {
         if(master_request_endpoints.size()==slave_endpoints.size())
         {
             log("Setting as root");
             master.setAsRoot(bluetoothaddress,localName);
             if(master.isRoot()) log("setted as root");
         }
         else
         {
             log("Asking - can i be slave");
             EndPoint masendpt;
             EndPoint tmpendpt;
             int exit=0;
             for(int i=0;i<slave_request_endpoints.size();i++)
             {
                    masendpt=(EndPoint) slave_request_endpoints.elementAt(i);
                     for(int j=0;j<slave_request_endpoints.size();j++)
                     {  
                        tmpendpt=(EndPoint) master_request_endpoints.elementAt(j);
                        if(masendpt.localmaster.compareTo(tmpendpt.localName)==0)
                        {
                            pseudorootmaster=true;
                            log("pseudomaster true");
                            master.setMasterID(masendpt);
                            masendpt.putString( NetLayer.SIGNAL_I_AM_UR_SLAVE, bluetoothaddress);
                            exit=1;
                            break;
                        }
                        
                     }
                    if(exit==1) break;
            }
            if(exit==0)
            {
                tmpendpt=(EndPoint)slave_request_endpoints.elementAt(0);
                master.setMasterID(tmpendpt);
                pseudorootmaster=true;
                log("pseudomaster true");
                
                tmpendpt.putString( NetLayer.SIGNAL_I_AM_UR_SLAVE, bluetoothaddress);
                for (int i = 0; i < slave_request_endpoints.size(); i++) {
                    EndPoint cancelenpt=(EndPoint)slave_request_endpoints.elementAt(i);
                    if(!cancelenpt.equals(tmpendpt))
                        cleanupRemoteEndPoint(cancelenpt);
                    }
                
            }
         }
     }
     else{
         for (int i = 0; i < slave_request_endpoints.size(); i++) {
             EndPoint tempt=(EndPoint)slave_request_endpoints.elementAt(i);
             cleanupRemoteEndPoint(tempt);
         }
         slave_request_endpoints.removeAllElements();
         master_request_endpoints.removeAllElements();
     }
    
    askSlavesToBeMaster();
     
 }
 public String createExclusionList(){
     String st="";
     for (int i = 0; i < slave_endpoints.size(); i++) {
         EndPoint tmpendpt = (EndPoint) slave_endpoints.elementAt( i );
         st=st+tmpendpt.remotebtaddr+";";
        
     }
     st=st+bluetoothaddress+";";  
     return st;
 }
 public void askSlavesToBeMaster()
 {
     log("invoke askSlavesToBeMaster");
     if(slave_endpoints.size()>0)
     {
        masterorder.MasterSlaveOrder(slave_endpoints.size(),this);
        exclusionstring= createExclusionList();
        log("created Exclusion list"+exclusionstring);
     
        for (int i = 0; i <slave_endpoints.size(); i++) 
        {
            EndPoint tmpendpt = (EndPoint) slave_endpoints.elementAt( i );
            tmpendpt.putString( NetLayer.SIGNAL_BE_MASTER_AND_DO_DISCOVERY,  exclusionstring);
        }
     }
     else
     {
         if(!master.isRoot())
         {
                if(pseudorootmaster)
                { 
                    log("Converting ACTED_AS_MASTER to ADD_UPDATE signal");
                    master.masterendpt.putString(NetLayer.SIGNAL_ADD_UPDATE,reachableSlaves());
                }
                else
                {   
                    log("2 Sending ACTED_AS_MASTER to " +master.btadder+"with name"+master.mastname);
                    master.masterendpt.putString(NetLayer.SIGNAL_ACTED_AS_MASTER,bluetoothaddress+":"+localName+";");
                }
         }
     }
     
 }
public String reachableSlaves()
{
    String s="";
    for (int i = 0; i < slave_endpoints.size(); i++) {
        EndPoint tmpendpt=(EndPoint) slave_endpoints.elementAt(i);
        for(int j=0;j< tmpendpt.reachableslaves.size();j++){
             String tmp=(String) tmpendpt.reachableslaves.elementAt(j);
             s=s+tmp+";";
        }
    }
     s=s+bluetoothaddress+":"+localName+";";
    
    return s;
}
public EndPoint slave(String s)
{
    log("involve slave");
        for (int i = 0; i < slave_endpoints.size(); i++)
        {
            
            EndPoint tmpendpt=(EndPoint) slave_endpoints.elementAt(i);
            for(int j=0;j< tmpendpt.reachableslaves.size();j++)
            {   
               
                String tmp=(String) tmpendpt.reachableslaves.elementAt(j);
                int k=tmp.indexOf(":");
                tmp=tmp.substring(0,k);
                if(s.compareTo(tmp)==0)
                {    
                   
                    return tmpendpt;
                }
            }
        }
        return null;
}
 public void slavesCompletedMasterAct()
 {
     if(!master.isRoot())
     {
         if(pseudorootmaster)
         { 
              log("Converting ACTED_AS_MASTER to ADD_UPDATE signal");
              master.masterendpt.putString(NetLayer.SIGNAL_ADD_UPDATE,reachableSlaves());
         }
         else
         {
                log("Sending ACTED_AS_MASTER to " +master.btadder+"with name"+master.mastname);
                master.masterendpt.putString(NetLayer.SIGNAL_ACTED_AS_MASTER,reachableSlaves());
         }
         
     }
     else if(master.isRoot())
     {
         
         log("Sending Full " +master.btadder+"with name"+master.mastname+reachableSlaves());
         nodes.addUpdate(reachableSlaves());
         broadcast(reachableSlaves());
     }
     
 }
 public void broadcast(String st)
 {
     log("Involve Broadcast");
     
     EndPoint tmpendpt;
     for (int i = 0; i < slave_endpoints.size(); i++) {
        
         tmpendpt=(EndPoint) slave_endpoints.elementAt(i);
         log("Involve Sending to:"+tmpendpt.remoteName);
         tmpendpt.putString(NetLayer.SIGNAL_SCATTERNET_BROADCAST_ADD,st);
     }
 }

 public void listSlaveAndMAster()
 {
     EndPoint tmpendpt;
     for (int i = 0; i < slave_endpoints.size(); i++) {

         tmpendpt=(EndPoint) slave_endpoints.elementAt(i);
         log(tmpendpt.remotebtaddr+"is a slave");
     }
     log("Master is "+master.btadder);
 }
 public  void exclusionExtractor(String s)
 {
      exclusionendpt.removeAllElements();
      while(true)
      {
            int i=s.indexOf(";");
            String temp=s.substring(0,i);
            exclusionendpt.addElement(temp);
            if(s.length()-1==s.indexOf(";")) break;
            s= s.substring(i+1);
      }
			
  }

 public void listAllDevices()
{
     String des[]=new String[nodes.getCount()];
     des=nodes.allNodes();
     for (int i = 0; i <nodes.getCount(); i++) {
         log(des[i]);
     }
}

 public boolean checkExclusionList(String btaddr){
     
     if(exclusionendpt.indexOf(btaddr)!=-1)
         return true;
     else 
         return false;
     
 }
 class Listener implements DiscoveryListener
 {
    // explain what to do if a device is discovered
     
    public void deviceDiscovered(RemoteDevice remoteDevice, DeviceClass deviceClass) {
     
       try {
       
                log("invoke deviceDiscovered name=" + remoteDevice.getFriendlyName(false)); 
                
            } catch (IOException ex) {
                ex.printStackTrace();
            }       
        try
        {
          if(!checkExclusionList(remoteDevice.getBluetoothAddress()))
          {      
                EndPoint endpt = new EndPoint(NetLayer.this, remoteDevice, null);
                pendingEndPoints.addElement( endpt );
          }
          else
           log("Excluded name=" + remoteDevice.getFriendlyName(false)) ;

        } catch (Exception e)
        {
          e.printStackTrace();
          log(e.getClass().getName()+" "+e.getMessage());

        }
    }

    public void inquiryCompleted(int i) {
            log( "invoke inqueryCompleted" );
            DoServiceDiscovery serdiscovery= new DoServiceDiscovery();
            Thread servicediscovery= new Thread(serdiscovery);
            servicediscovery.start();
    }

    

    class DoServiceDiscovery implements Runnable{
         public void run()
        {
             
            // for each EndPoint, we search for Scatternet service
            for (int i = 0; i < pendingEndPoints.size(); i++)
            {

                EndPoint endpt = (EndPoint) pendingEndPoints.elementAt(i);

                try {
                    log("search service on device " + endpt.remoteName);

                    // searchServices return a transaction id, which we will used to
                    // identify which remote device the service is found in our callback
                     // listener 
                    endpt.transID = agent.searchServices(null // null to indicate retrieve default attributes
                                               ,
                                               new UUID[] { uuid }  // Scatternet service UUID SerialPort
                                               ,
                                               endpt.remoteDev,
                                               new Listener());
                    log("Transaction id"+String.valueOf(endpt.transID)); 
                    endpointserRcd.addElement(endpt);// vector
                    // wait until the above service discovery is completed
                    synchronized( lock )
                    {
                         try {
                                lock.wait();
                         }
                         catch (InterruptedException ex) {
                         }
                    }
                 }
                 catch (BluetoothStateException e) {
                    e.printStackTrace();
                    log(e.getClass().getName()+" "+e.getMessage());
                    
                 }

      } // for

      // no more service to discovery. so any pending EndPoints
      // will be ignored and removed
      //pendingEndPoints.removeAllElements();
      
     Scattercom.instance.gui_log( "", "Master Request Sending..." );
     canIBeMaster();
     
    }

  } 

 public void servicesDiscovered(int transId, ServiceRecord[] svcRec) {
            log( "invoke servicesDiscovered:"+transId+","+svcRec.length);
            try {

                /*for ( int i=0; i< svcRec.length; i++ )
                {
                    
                    EndPoint endpt = findEndPointByTransId( transId );
                    
                    serviceRecordToEndPoint.put( svcRec[i], endpt );
                    
                    
                }*/
                serviceRecord.addElement(svcRec[0]);//vector
            }
            catch (Exception e) {
                e.printStackTrace();
                log(e.getClass().getName());
                log(e.getMessage());
            }
      }

    public void serviceSearchCompleted(int transID, int respCode) {
     log("invoke serviceSearchCompleted: "+transID);
      // print response code
      
      if ( respCode == SERVICE_SEARCH_TERMINATED )
      {     log("SERVICE_SEARCH_TERMINATED");
            serviceRecord.removeAllElements();
            endpointserRcd.removeAllElements();
      }
      else if ( respCode == SERVICE_SEARCH_ERROR )
      { log("SERVICE_SEARCH_ERROR");
        serviceRecord.removeAllElements();
        endpointserRcd.removeAllElements();
      }
      else if ( respCode == SERVICE_SEARCH_NO_RECORDS )
      { log("SERVICE_SEARCH_NO_RECORDS");
        serviceRecord.removeAllElements();
        endpointserRcd.removeAllElements();
      }
      else if ( respCode == SERVICE_SEARCH_DEVICE_NOT_REACHABLE )
      {  log("SERVICE_SEARCH_DEVICE_NOT_REACHABLE");
         serviceRecord.removeAllElements();
         endpointserRcd.removeAllElements();
      }
      else  if ( respCode == SERVICE_SEARCH_COMPLETED )
      {   log("SERVICE_SEARCH_COMPLETED");
            
     // for ( Enumeration records = serviceRecordToEndPoint.keys(); records.hasMoreElements(); )
      {
        try {
                //ServiceRecord rec = (ServiceRecord) records.nextElement();
                ServiceRecord rec = (ServiceRecord) serviceRecord.elementAt(0);
                String url  = rec.getConnectionURL( ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false );
                log("Service url="+url);
                StreamConnection con = (StreamConnection)Connector.open( url );

                //EndPoint endpt = (EndPoint) serviceRecordToEndPoint.get( rec );
                EndPoint endpt=(EndPoint) endpointserRcd.elementAt(0);
                if ( endpt != null )
                {
                        endpt.con = con;
                        Thread t1 = new Thread( endpt.sender );
                        t1.start();
                        Thread t2 = new Thread( endpt.reader );
                        t2.start();
                        master_request_endpoints.addElement( endpt );
                        endpoints.addElement(endpt);
                        log("a new active EndPoint is established. name=" + endpt.remoteName);
                        
                }
                else
                {
                    log("cannot find pending EndPoint when a service is discovered. ignore this service...");
                }

        } catch (Exception e)
        {
          e.printStackTrace();
          log(e.getClass().getName()+" "+e.getMessage());

        }
        serviceRecord.removeAllElements();
        endpointserRcd.removeAllElements();
      } // for
      }//Service Search Complete
      // finished process current batch of service record
      // clear it and service discovery on next device
      serviceRecordToEndPoint.clear();

      synchronized( lock )
      {
        lock.notifyAll();
      }

    }
     public EndPoint findEndPointByTransId( int id )
    {
        for ( int i=0; i < pendingEndPoints.size(); i++ )
        {
            EndPoint endpt = (EndPoint) pendingEndPoints.elementAt( i );
            if ( endpt.transID == id )
            {
                return endpt;
            }
        }
        return null; 
    }
}


   public static void log( String s)
  {
    System.out.println("NetLayer: "+s);

    // "N" means NetLayer
    Scattercom.instance.gui_log( "N", s );

  }
   
}

