

import java.io.*;
import javax.microedition.lcdui.Display;

public class Reader implements Runnable{
    public EndPoint endpt;
    private boolean done = false;
    public Reader() {
    }
    public void stop()
    {
        done = true;
    }
    public void run() {
        try
        {
            DataInputStream datain = endpt.con.openDataInputStream();
            while ( !done )
            {
                 log("waiting for next signal from "+endpt.remoteName);
                 int signal = datain.readInt();
                 if ( signal == NetLayer.SIGNAL_MESSAGE || signal == NetLayer.SIGNAL_VIEW_PROFILE || signal == NetLayer.SIGNAL_PROFILE
                         || signal==NetLayer.SIGNAL_SCRAP_RESPONSE||signal==NetLayer.SIGNAL_SUBMIT_SCRAP ||signal==NetLayer.SIGNAL_CONTACTS_NAME_REQUEST
                            || signal==NetLayer.SIGNAL_CONTACTS_NUM_REQUEST||signal==NetLayer.SIGNAL_CONTACTS_RESPONSE||signal==NetLayer.SIGNAL_FILE_SEARCH_REQUEST
                            || signal==NetLayer.SIGNAL_FILE_SEARCH_RESPONSE)
                 {
                     log("Obtained signal");
                     String msg = datain.readUTF();
                     String sender=datain.readUTF();
                     String destination=datain.readUTF();
                     Packet packet = new Packet(sender,destination,signal,msg);
                     log("sender: "+ sender +"dest: "+destination);
                     
                     log("got list");
                     if(endpt.btnet.bluetoothaddress.compareTo(destination)==0)
                     {  
                         log("same destination");
                         if(signal == NetLayer.SIGNAL_MESSAGE)   
                            endpt.callback.handleAction( SubsystemInvoker.EVENT_MESSAGE, endpt, packet );
                        else if(signal == NetLayer.SIGNAL_VIEW_PROFILE)
                        { log("view Profile got ");
                           endpt.btnet.sendString(NetLayer.SIGNAL_PROFILE,Scattercom.profileinfo.getInfo(),destination,sender);
                           endpt.btnet.sendString(NetLayer.SIGNAL_SCRAP_RESPONSE,Scattercom.myscrapresults.msrs.TheMessage,destination,sender);
                        }
                        else if(signal == NetLayer.SIGNAL_PROFILE) 
                            endpt.callback.handleAction( SubsystemInvoker.EVENT_PROFILE, endpt, packet );
                        else if(signal == NetLayer.SIGNAL_SUBMIT_SCRAP)
                        {
                             Scattercom.myscrapresults.msrs.WriteRec(endpt.btnet.nodes.getName(sender),msg);
                             Scattercom.myscrapresults.msrs.RecToStr();
                             endpt.btnet.sendString(NetLayer.SIGNAL_SCRAP_RESPONSE,Scattercom.myscrapresults.msrs.TheMessage,destination,sender);
                             endpt.callback.handleAction( SubsystemInvoker.EVENT_SCRAP, endpt, packet );
                        } 
                        else if (signal==NetLayer.SIGNAL_SCRAP_RESPONSE)
                        {
                             Scattercom.myscrapresults.AddScrap2Vector(msg);
                             
                             
                        }
                        else if (signal==NetLayer.SIGNAL_FILE_SEARCH_REQUEST)
                        {
                             Scattercom.instance.fsi.netFileRetrieve(msg,sender,destination);
                        }
                        else if (signal==NetLayer.SIGNAL_FILE_SEARCH_RESPONSE)
                        {
                             Scattercom.instance.fsi.netDisplay(msg);
                        } 
                        else if (signal==NetLayer.SIGNAL_CONTACTS_NAME_REQUEST)
                        {
                             Scattercom.instance.csi.netNameRetrieve(msg,sender,destination);
                     
                        } 
                        else if (signal==NetLayer.SIGNAL_CONTACTS_NUM_REQUEST)
                        {
                             Scattercom.instance.csi.netNumRetrieve(msg,sender,destination);
                     
                        }
                        else if (signal==NetLayer.SIGNAL_CONTACTS_RESPONSE)
                        {
                             Scattercom.instance.csi.netDisplay(msg);
                        }  

                     }
                     else
                         endpt.btnet.sendString(signal,msg,sender,destination);
                     
                 }
                 else if ( signal == NetLayer.SIGNAL_MASTER_REQUEST )
                 {
                     String s = datain.readUTF();
                     log("read in MASTER_REQUEST from bluetooth address "+s+" from "+endpt.remoteName );
                     if(!endpt.btnet.master.setMasterID(endpt))
                     {
                         log("master id already set");
                         log("Sending CANT_BE_SLAVE to "+s+" with name: "+endpt.remoteName );
                         endpt.putString( NetLayer.SIGNAL_CANT_BE_SLAVE,endpt.btnet.master.btadder);
                     }
                     else
                     {
                         
                         log("Sending I_AM_UR_SLAVE to "+s+" with name: "+endpt.remoteName );
                         endpt.putString(NetLayer.SIGNAL_I_AM_UR_SLAVE,endpt.btnet.bluetoothaddress);
                     }
                     
                 }
                 else if ( signal == NetLayer.SIGNAL_I_AM_UR_SLAVE )
                 {
                     
                     String s = datain.readUTF();
                     log("read in  I_AM_UR_SLAVE from "+s+" with name: "+endpt.remoteName);
                     //log("the value of request now "+ String.valueOf(endpt.btnet.masterreq.request));
                     endpt.btnet.slave_endpoints.addElement(endpt);
                     log("entered into slave list");
                     endpt.btnet.masterreq.decrement();
                     
                 }
                 else if ( signal == NetLayer.SIGNAL_CANT_BE_SLAVE )
                 {
                     
                     String s = datain.readUTF();
                     endpt.localmaster=s;
                     log("read in CANT_BE_SLAVE from "+s+" with name: "+endpt.remoteName);
                     endpt.btnet.slave_request_endpoints.addElement(endpt);
                     log("the value of request now "+ String.valueOf(endpt.btnet.masterreq.request));
                     endpt.btnet.masterreq.decrement();
                     
                 }
                 else if ( signal == NetLayer.SIGNAL_BE_MASTER_AND_DO_DISCOVERY )
                 {
                     String s = datain.readUTF();
                     log("read in BE_MASTER_AND_DO_DISCOVERY from "+ endpt.remoteName +" With Bluetooth Address: "+endpt.remotebtaddr);
                     log("read in Exclusion List"+s);
                     endpt.btnet.exclusionExtractor(s);
                     //Thread.sleep(10000); 
                     endpt.btnet.query();
                 }
                 else if ( signal == NetLayer.SIGNAL_ACTED_AS_MASTER)
                 {
                     String s = datain.readUTF();
                     log("read in ACTED_AS_MASTER from "+ endpt.remoteName +" With Bluetooth Address: "+endpt.remotebtaddr+" and String: "+s);
                     endpt.slavesExtractor(s);
                     endpt.btnet.masterorder.decrement();
         
                 }
                else if ( signal == NetLayer.SIGNAL_ADD_UPDATE)
                 {
                     String s = datain.readUTF();
                     log("read in ADD_UPDATE from "+ endpt.remoteName +" With Bluetooth Address: "+endpt.remotebtaddr+" and String: "+s);
                     endpt.slavesExtractor(s);
                     if(endpt.btnet.master.isRoot())
                     {
                         endpt.btnet.nodes.addUpdate(s);
                         endpt.btnet.broadcast(endpt.btnet.reachableSlaves());
                     }    
                     else
                         endpt.btnet.master.masterendpt.putString(NetLayer.SIGNAL_ADD_UPDATE,s);
         
                 }
                 else if ( signal == NetLayer.SIGNAL_SCATTERNET_BROADCAST_ADD )
                 {
                     String s = datain.readUTF();
                     log("read in SCATTERNET_BROADCAST from "+ endpt.remoteName +" With Bluetooth Address: "+endpt.remotebtaddr+"with mess "+s);
                     endpt.btnet.nodes.addUpdate(s);
                     endpt.btnet.broadcast(s);      
                 }

                 else if ( signal == NetLayer.SIGNAL_TERMINATE )
                 {
                     log("read in TERMINATE from "+endpt.remoteName);
                     endpt.putString( NetLayer.SIGNAL_TERMINATE_ACK, "end" );
                     endpt.callback.handleAction( SubsystemInvoker.EVENT_LEAVE, endpt, null );
                     endpt.btnet.cleanupRemoteEndPoint( endpt );
                     stop();
                 }
                 
                 else if ( signal == NetLayer.SIGNAL_TERMINATE_ACK )
                 {
                     
                 }
                
                 else
                {
                    log("Unkonwn signal, probably connection closed");
                }
                 
                 
    
            }
            datain.close();
    } catch (Exception e)
    {
        
      e.printStackTrace();
      log(e.getClass().getName()+" "+e.getMessage());
      log("device disconnected");
    }
    log("reader thread exit for "+endpt.remotebtaddr);
  }
    
  private static void log( String s)
  {
        // "R" means Reader class
   
      Scattercom.instance.gui_log( "R", s );
  }  
    
}
